# Tests for dining_phil_live
#
# @Author: Christopher Hylands Brooks
#
# @Version: $Id: dining_phil_live.tcl,v 1.2 2004/05/27 19:50:58 cxh Exp $
#
# @Copyright (c) 2004 The Regents of the University of California.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in all
# copies of this software and that appropriate acknowledgments are made
# to the research of the Metropolis group.
# 
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
# THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
# CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
# ENHANCEMENTS, OR MODIFICATIONS.
#
# 						PT_COPYRIGHT_VERSION_2
# 						COPYRIGHTENDKEY
#######################################################################

# Load up the test definitions.
if {[string compare test [info procs test]] == 1} then {
    source testDefs.tcl
} {}

# Uncomment this to get a full report, or set in your Tcl shell window.
# set VERBOSE 1

set TESTDIR [pwd]
######################################################################
####
#
test dining_phil_live-1.1 {Create run.x and constrN.check} {
    cd ..	
    set errMsg {}
    if [catch {exec -stderrok make -k} errMsg] {
	cd test
	error "dining_phil_live-1.1 failed: $errMsg"
    }

    if {! [ file exists .[java::field java.io.File separator]run.x]} {
	error ".[java::field java.io.File separator]run.x does not exist"
    }

    # Let it run for 2 seconds
    if [catch {set results \
		   [exec -stderrok \
			[file join $METRO util testsuite run-watchdog] -n 2 \
			.[java::field java.io.File separator]run.x]} errMsg] {
	cd test
	error "dining_phil_live-1.1 failed: $errMsg"
    }
    cd $TESTDIR

    regsub {^ *SystemC 2\.0.*$} $results {} results2
    regsub {^ *Copyright.*$} $results2 {} results3
    regsub -all {cps.*$} $results3 {cpsXXX} results4
    regsub -all {Phil[0-4]} $results4 {PhilN} results5
    regsub -all {Chopstick[0-4]} $results5 {ChopstickN} results6

    list [string range $results6 0 1024]
} {{Set execution order of processes
Begin setting up connections
- processes to media
- media to media
- processes to statemedia
- media to statemedia
- quantities to statemedia
- quantities to quantities
- statemedia to quantities
PhilN: Start thinking 1
PhilN: Start thinking 1
PhilN: Start thinking 1
PhilN: Start thinking 1
PhilN: Finished thinking 1
PhilN: Finished thinking 1
PhilN: Finished thinking 1
PhilN: Finished thinking 1
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN: got ChopstickN
PhilN try to use the ChopstickN
PhilN: got ChopstickN
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN try to use the ChopstickN
PhilN: got ChopstickN
PhilN try to use the ChopstickN
PhilN: Got both  cpsXXX
PhilN: Start eating4
PhilN try to use the ChopstickN
PhilN: got ChopstickN
PhilN try to release the ChopstickN
PhilN try to use the ChopstickN
PhilN: }}
