#include "tracesim.h"

bool verbose=0, trace=0;

TraceList::TraceList(const char *filename) {
  ifstream fin;
  char name[10];
  unsigned int i, j, x, temp;



  curr_inst_num=0; // start from the bottom
  temp = getNumLines(filename);
  fin.open(filename);

  trace_list = new (CTraceInst*)[temp];



  // Read in the trace information
  x=0;
  while (fin.peek() != EOF) {
    fin >> name >> std::hex >> i >> std::hex >> j;
    //printf("%s %08x %08x\n", name, i, j);

    // read valid instructions
    if (strcmp(name, "NO") != 0) {
      trace_list[x] = new CTraceInst(i, j, (strcmp(name, "EX")==0));
      x++;
    }
  }

  size = x;


  fin.close();
}

TraceList::~TraceList() {
  for (int x=0; x<temp; x++)
    delete trace_list[x];  
  delete trace_list;
}


unsigned int TraceList::getNumLines(const char *filename) {
  const static unsigned int MAXCHAR = 1024; // max line length in characters
  std::ifstream file(filename);
  if (!file) return 0;     // Some error message here, file not found
  unsigned int kount = 0;
  while (file.peek() != EOF) {
    ++kount;
    file.ignore(MAXCHAR, '\n');
  } 
  file.close();

  return kount;
}

unsigned int TraceList::getSize() {
  return size;
}

CTraceInst* TraceList::getInst(int i) {
  //curr_inst_num++;

  return trace_list[i];
}

/*
unsigned int TraceList::getCurrInstNum() {
  return curr_inst_num;
}
*/

bool TraceList::isFinished() {
  return (curr_inst_num >= size);
}

void TraceList::print() {
  for (int x=0; x<size; x++) {
    printf("inst %d: ", x);
    trace_list[x]->print();
  }
}


/*

int main(int argc, char* argv[]) {
  TraceList *tlist;

  if (argc < 2) {
    cerr << argc << endl << "Usage: tracesim <trace_file_name>\n";
    exit(-1);
  } 
  
  tlist = new TraceList(argv[1]);
  tlist->print();

  delete tlist;

  return 0;
}
*/
