/* MMDebugError

Metropolis: Design Environment for Heterogeneus Systems.

Copyright (c) 1998-2004 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software and that appropriate acknowledgments are made
to the research of the Metropolis group.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.


METROPOLIS_COPYRIGHT_VERSION_1
COPYRIGHTENDKEY
*/


package metropolis.metamodel.backends.systemc.mmdebug;

import metropolis.metamodel.MetaModelStaticSemanticConstants;
import metropolis.metamodel.TreeNode;

//////////////////////////////////////////////////////////////////////////
//// MMDebugError
/**
 * This is a utility class to put together information about an error
 * in preparing for metamodel debugging.
 *
 * @author   Allen Hopkins
 * @version  $Id: MMDebugError.java,v 1.5 2004/05/20 07:12:23 cxh Exp $
 */
public class MMDebugError
    implements MetaModelStaticSemanticConstants {

    ///////////////////////////////////////////////////////////////////
    ////                     constructorsds

    public MMDebugError(TreeNode node, String message) {
        _node = node;
        _message = message;
    }

    ///////////////////////////////////////////////////////////////////
    ////                     public methods

    public String toString() {
        StringBuffer buf = new StringBuffer();
        String fileName = (String)_node.getProperty(IDENT_KEY);
        Integer lineNumber = (Integer)_node.getProperty(LINENUMBER_KEY);

        if (fileName != null) {
            buf.append(fileName);
            buf.append(": ");
        }

        if (lineNumber != null) {
            buf.append("line ");
            buf.append(lineNumber);
            buf.append(": ");
        }

        buf.append(_message);
        return buf.toString();
    }

    ///////////////////////////////////////////////////////////////////
    ////                     private members

    private String   _message = null;
    private TreeNode _node    = null;
}
