# Tests for INode class in the runtime
#
# @Author: Christopher Hylands Brooks
#
# @Version: $Id: INode.tcl,v 1.3 2004/05/20 03:38:14 cxh Exp $
#
# @Copyright (c) 2004 The Regents of the University of California.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in all
# copies of this software and that appropriate acknowledgments are made
# to the research of the Metropolis group.
# 
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
# THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
# CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
# ENHANCEMENTS, OR MODIFICATIONS.
#
# 						PT_COPYRIGHT_VERSION_2
# 						COPYRIGHTENDKEY
#######################################################################

# Load up the test definitions.
if {[string compare test [info procs test]] == 1} then {
    source testDefs.tcl
} {}

# Uncomment this to get a full report, or set in your Tcl shell window.
# set VERBOSE 1

######################################################################
####
#
test INode-1.1 {constructor} {
    # Very similar to IPortArray-1.1
    set superClass [java::null]
    set superInterfaces [java::null]
    set mmTypeInterface [java::new metropolis.metamodel.runtime.MMType \
	    myMMTypeInterface \
	    [java::field metropolis.metamodel.runtime.MMType INTERFACE ] \
	    $superClass \
	    $superInterfaces]

    set mmType [java::new metropolis.metamodel.runtime.MMType \
	    myMMType \
	    [java::field metropolis.metamodel.runtime.MMType CLASS] \
	    $superClass \
	    $superInterfaces]

    set mmPort [java::new metropolis.metamodel.runtime.MMPort \
		    myMMPort $mmTypeInterface $mmType]

    $mmTypeInterface addPort $mmPort

    set iNode [java::new metropolis.metamodel.runtime.INode \
		   $mmTypeInterface iNodeObject myINode 42]
    set iNode2 [java::new metropolis.metamodel.runtime.INode \
		   $mmTypeInterface iNodeObject "" 42]

    list \
	    [$iNode show] \
	    [$iNode2 show]
} {{interface myMMTypeInterface {
  o Instance name: myINode
  o Component name:
  o Ports:
       myMMTypeInterface myMMPort
  o Not refined by a netlist
  o No constraints
}} {interface myMMTypeInterface {
  o Instance name: myMMTypeInterface0
  o Component name:
  o Ports:
       myMMTypeInterface myMMPort
  o Not refined by a netlist
  o No constraints
}}}
